Qore Programming Language: QoreSSLPrivateKey Class Reference

Qore Programming Language 0.8.11

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | List of all members
QoreSSLPrivateKey Class Reference

provides access to a private key data structure for SSL connections More...

`#include <QoreSSLPrivateKey.h>`

Inheritance diagram for QoreSSLPrivateKey:
[legend]
Collaboration diagram for QoreSSLPrivateKey:
[legend]

## Public Member Functions
DLLEXPORT | QoreSSLPrivateKey (const char *fn, const char *pp, ExceptionSink *xsink)
| creates the object from a file name by reading in the file in PEM format More...
DLLEXPORT | QoreSSLPrivateKey (const BinaryNode *bin, ExceptionSink *xsink)
| creates the object from a pointer to a BinaryNode object (key data in DER format) More...
DLLEXPORT | QoreSSLPrivateKey (const QoreString *str, const char *pp, ExceptionSink *xsink)
| create the object from a pointer to a QoreString representing the private key data in PEM format More...
DLLLOCAL | QoreSSLPrivateKey (EVP_PKEY *p)
| private constructor; not exported
DLLEXPORT int64 | getBitLength () const
| returns the length in bits
DLLEXPORT QoreHashNode * | getInfo () const
| caller owns the QoreHashNode reference count returned
DLLEXPORT QoreStringNode * | getPEM (ExceptionSink *xsink) const
| returns a string in PEM format representing the private key, caller owns the QoreString reference count returned More...
DLLEXPORT int64 | getVersion () const
| returns a constant '1': do not use; only included for backwards-compatibility
Public Member Functions inherited from AbstractPrivateData
virtual DLLLOCAL void | deref (class ExceptionSink *xsink)
| decrements the reference count of the object More...
virtual DLLLOCAL void | deref ()
| decrements the reference count of the object without the possibility of throwing a Qore-language exception
DLLLOCAL void | ref ()
| increments the reference count of the object
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLLOCAL bool | is_unique () const
| returns true if the reference count is 1 More...
DLLLOCAL int | reference_count () const
| gets the reference count More...
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count More...
DLLEXPORT void | ROreference () const
| atomically increments the reference count

## Additional Inherited Members
Protected Member Functions inherited from AbstractPrivateData
virtual DLLLOCAL | ~AbstractPrivateData ()
| as these objects are reference counted, the destructor should be called only when the reference count = 0 and not manually
Protected Attributes inherited from QoreReferenceCounter
QoreThreadLock | mRO
| pthread lock to ensure atomicity of updates for architectures where we don't have an atomic increment and decrement implementation

## Detailed Description

provides access to a private key data structure for SSL connections

## Constructor & Destructor Documentation

DLLEXPORT QoreSSLPrivateKey::QoreSSLPrivateKey | ( | const char * | fn,
|  | const char * | pp,
|  | ExceptionSink * | xsink
| ) |  |

creates the object from a file name by reading in the file in PEM format

Parameters

  fn | the filename of the private key file to open (must be in PEM format)
  pp | the pass phase for the key (if any; may be NULL)
  xsink | Qore-language exceptions are raised here in case of errors

DLLEXPORT QoreSSLPrivateKey::QoreSSLPrivateKey | ( | const BinaryNode * | bin,
|  | ExceptionSink * | xsink
| ) |  |

creates the object from a pointer to a BinaryNode object (key data in DER format)

Parameters

  bin | a pointer to a BinaryNode object with the raw binary private key information
  xsink | Qore-language exceptions are raised here in case of errors

DLLEXPORT QoreSSLPrivateKey::QoreSSLPrivateKey | ( | const QoreString * | str,
|  | const char * | pp,
|  | ExceptionSink * | xsink
| ) |  |

create the object from a pointer to a QoreString representing the private key data in PEM format

Parameters

  str | a pointer to a QoreString with the private key data in PEM format
  pp | the pass phase for the key (if any; may be NULL)
  xsink | Qore-language exceptions are raised here in case of errors

## Member Function Documentation

DLLEXPORT QoreStringNode* QoreSSLPrivateKey::getPEM | ( | ExceptionSink * | xsink | ) | const

returns a string in PEM format representing the private key, caller owns the QoreString reference count returned

Returns
  a string in PEM format representing the private key, caller owns the QoreString reference count returned

The documentation for this class was generated from the following file:

- include/qore/QoreSSLPrivateKey.h (6585)